## API Report File for "dwv"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import Konva from 'konva';

// @public
export function addTagsToDictionary(group: string, tags: object): void;

// @public
export class App {
    abortLoad(): void;
    addDataViewConfig(dataId: string, config: ViewConfig): void;
    addEventListener(type: string, callback: Function): void;
    addNewImage(image: Image_2, meta: object): string;
    addToUndoStack: (cmd: object) => void;
    applyJsonState(jsonState: string): void;
    canScroll(): boolean;
    canWindowLevel(): boolean;
    defaultOnKeydown: (event: KeyboardEvent) => void;
    fitToContainer(): void;
    getActiveLayerGroup(): LayerGroup;
    getAddedScale(): object;
    getBaseScale(): object;
    getCurrentStackIndex(): number;
    getDataIds(): any[];
    getDataViewConfigs(): {
        [x: string]: ViewConfig[];
    };
    getDrawLayersByDataId(dataId: string): DrawLayer[];
    getImage(dataId: string): Image_2;
    getJsonState(): string;
    getLastImage(): Image_2;
    getLayerGroupByDivId(divId: string): LayerGroup;
    getMetaData(dataId: string): object;
    getNumberOfLayerGroups(): number;
    getOffset(): object;
    getOverlayData(dataId: string): OverlayData | undefined;
    getStackSize(): number;
    getStyle(): object;
    getToolboxController(): ToolboxController;
    getViewLayersByDataId(dataId: string): ViewLayer[];
    init(opt: AppOptions): void;
    initWLDisplay(): void;
    loadFiles: (files: File[]) => void;
    loadFromUri: (uri: string, options?: object) => void;
    loadImageObject: (data: any[]) => void;
    loadURLs: (urls: string[], options?: object) => void;
    onKeydown: (event: KeyboardEvent) => void;
    onResize: () => void;
    redo(): void;
    removeDataViewConfig(dataId: string, config: ViewConfig): void;
    removeEventListener(type: string, callback: Function): void;
    render(dataId: string, viewConfigs?: ViewConfig[]): void;
    reset(): void;
    resetDisplay(): void;
    resetLayout(): void;
    resetZoom(): void;
    setColourMap(name: string): void;
    setDataViewConfigs(configs: {
        [x: string]: ViewConfig[];
    }): void;
    setDrawings(drawings: any[], drawingsDetails: any[]): void;
    setImage(dataId: string, img: Image_2): void;
    setImageSmoothing(flag: boolean): void;
    setLastImage(img: Image_2): void;
    setLayerGroupsBinders(list: any[]): void;
    setOpacity(alpha: number): void;
    setTool(tool: string): void;
    setToolFeatures(list: object): void;
    setWindowLevelPreset(preset: object): void;
    toggleOverlayListeners(dataId: string): void;
    translate(tx: number, ty: number): void;
    undo(): void;
    updateDataViewConfig(dataId: string, divId: string, config: ViewConfig): void;
    zoom(step: number, cx: number, cy: number): void;
}

// @public
export class AppOptions {
    constructor(dataViewConfigs?: {
        [x: string]: ViewConfig[];
    });
    binders: string[] | undefined;
    dataViewConfigs: {
        [x: string]: ViewConfig[];
    } | undefined;
    defaultCharacterSet: string | undefined;
    overlayConfig: object | undefined;
    tools: {
        [x: string]: ToolConfig;
    } | undefined;
    viewOnFirstLoadItem: boolean | undefined;
}

// @public
export function buildMultipart(parts: any[], boundary: string): Uint8Array;

// @public
export class ColourMap {
    constructor(red: number[], green: number[], blue: number[]);
    blue: number[];
    green: number[];
    red: number[];
}

// @public
export function createImage(elements: object): Image_2;

// @public
export function createMaskImage(elements: object): Image_2;

// @public
export function createView(elements: object, image: Image_2): View;

// @public (undocumented)
export namespace customUI {
    export function openRoiDialog(data: any, callback: Function): void;
}

// @public
export class DataElement {
    constructor(vr: string);
    endOffset: number;
    items: any[];
    startOffset: number;
    tag: Tag;
    undefinedLength: boolean;
    value: any[];
    vl: number;
    vr: string;
}

// @public
export const decoderScripts: {
    jpeg2000: string;
    'jpeg-lossless': string;
    'jpeg-baseline': string;
    rle: string;
};

// @public
export const defaultPresets: {
    [x: string]: {
        [x: string]: {
            center: number;
            width: number;
        };
    };
};

// @public (undocumented)
export namespace defaults {
    let // (undocumented)
    labelText: {
        [x: string]: {
            [x: string]: string;
        };
    };
}

// @public
export class DicomParser {
    getDefaultCharacterSet(): string;
    getDicomElements(): {
        [x: string]: DataElement;
    };
    parse(buffer: ArrayBuffer): void;
    setDecoderCharacterSet(characterSet: string): void;
    setDefaultCharacterSet(characterSet: string): void;
}

// @public
export class DicomWriter {
    getBuffer(dataElements: {
        [x: string]: DataElement;
    }): ArrayBuffer;
    getElementToWrite(element: DataElement): DataElement | null;
    setRules(rules: {
        [x: string]: WriterRule;
    }): void;
    setUseUnVrForPrivateSq(flag: boolean): void;
    useDefaultAnonymisationRules(): void;
    useSpecialTextEncoder(): void;
}

// @public
export class DrawController {
    constructor(drawLayer: DrawLayer);
    activateDrawLayer(index: Index, scrollIndex: number): void;
    deleteDraw(id: string, cmdCallback: Function, exeCallback: Function): boolean;
    deleteDrawGroup(group: Konva.Group, cmdCallback: object, exeCallback: object): void;
    deleteDraws(cmdCallback: Function, exeCallback: Function): void;
    getCurrentPosGroup(): Konva.Group | undefined;
    getDrawDisplayDetails(): DrawDetails[];
    getDrawStoreDetails(): object;
    getGroup(id: string): object | undefined;
    reset(): void;
    setDrawings(drawings: any[], drawingsDetails: DrawDetails[], cmdCallback: object, exeCallback: object): void;
    updateDraw(drawDetails: DrawDetails): void;
}

// @public
export class DrawDetails {
    color: string;
    id: number;
    meta: DrawMeta;
    position: string;
    type: string;
}

// @public
export class DrawLayer {
    constructor(containerDiv: HTMLDivElement);
    addEventListener(type: string, callback: Function): void;
    addFlipOffsetX(): void;
    addFlipOffsetY(): void;
    bindInteraction(): void;
    deleteDraw(id: string, exeCallback: object): void;
    deleteDraws(exeCallback: object): void;
    display(flag: boolean): void;
    draw(): void;
    fitToContainer(fitScale1D: number, fitSize: object, fitOffset: object): void;
    flipScaleZ(): void;
    getBaseSize(): object;
    getDataId(): string;
    getDrawController(): object;
    getId(): string;
    getKonvaLayer(): Konva.Layer;
    getKonvaStage(): Konva.Stage;
    getOpacity(): number;
    initialise(size: object, spacing: object, dataId: string): void;
    isGroupVisible(id: string): boolean;
    isVisible(): boolean;
    removeEventListener(type: string, callback: Function): void;
    setBaseOffset(scrollOffset: Vector3D, planeOffset: Vector3D): boolean;
    setCurrentPosition(position: Point, index: Index): boolean;
    setOffset(newOffset: object): void;
    setOpacity(alpha: number): void;
    setPlaneHelper(helper: object): void;
    setScale(newScale: object, center?: Point3D): void;
    toggleGroupVisibility(id: string): boolean;
    unbindInteraction(): void;
}

// @public
export class DrawMeta {
    quantification: object;
    textExpr: string;
}

// @public
export class Geometry {
    constructor(origin: Point3D, size: Size, spacing: Spacing, orientation?: Matrix33, time?: number);
    appendFrame(origin: Point3D, time: number): void;
    appendOrigin(origin: Point3D, index: number, time?: number): void;
    equals(rhs: Geometry): boolean;
    getCurrentNumberOfSlicesBeforeTime(time: number): number | undefined;
    getCurrentTotalNumberOfSlices(): number;
    getInitialTime(): number;
    getOrientation(): Matrix33;
    getOrigin(): Point3D;
    getOrigins(): Point3D[];
    getRealSpacing(): Spacing;
    getSize(viewOrientation?: Matrix33): Size;
    getSliceIndex(point: Point3D, time: number): number;
    getSpacing(viewOrientation?: Matrix33): Spacing;
    hasSlicesAtTime(time: number): boolean;
    includesOrigin(point3D: Point3D, tol: number): boolean;
    indexToWorld(index: Index): Point;
    isInBounds(point: Point): boolean;
    isIndexInBounds(index: Index, dirs?: number[]): boolean;
    pointToWorld(point: Point3D): Point3D;
    toString(): string;
    worldToIndex(point: Point): Index;
    worldToPoint(point: Point): Point3D;
}

// @public
export function getDefaultDicomSegJson(): object;

// @public
export function getDwvVersion(): string;

// @public
export function getElementsFromJSONTags(jsonTags: {
    [x: string]: any;
}): {
    [x: string]: DataElement;
};

// @public
export function getEllipseIndices(center: Index, radius: any[], dir: any[]): any[];

// @public
export function getLayerDetailsFromEvent(event: object): object;

// @public
export function getOrientationName(orientation: any[]): string;

// @public
export function getPixelDataTag(): Tag;

// @public
export function getReverseOrientation(ori: string): string;

// @public
export function getTagFromKey(key: string): Tag;

// @public
export function getTypedArray(bitsAllocated: number, pixelRepresentation: number, size: number): Uint8Array | Int8Array | Uint16Array | Int16Array | Uint32Array | Int32Array;

// @public
export function getUID(tagName: string): string;

// @public
export function hasDicomPrefix(buffer: ArrayBuffer): boolean;

// @public (undocumented)
export namespace i18n {
    export function t(key: string): string;
}

// @public
class Image_2 {
    constructor(geometry: Geometry, buffer: Int8Array | Uint8Array | Int16Array | Uint16Array | Int32Array | Uint32Array, imageUids?: any[]);
    addEventListener(type: string, callback: Function): void;
    appendFrame(time: number, origin: Point3D): void;
    appendFrameBuffer(frameBuffer: object, frameIndex: number): void;
    appendSlice(rhs: Image_2): void;
    calculateDataRange(): object;
    calculateHistogram(): object;
    calculateRescaledDataRange(): object;
    canQuantify(): boolean;
    canScroll(viewOrientation: Matrix33): boolean;
    canWindowLevel(): boolean;
    clone(): Image_2;
    compose(rhs: Image_2, operator: Function): Image_2;
    convolute2D(weights: any[]): Image_2;
    convoluteBuffer(weights: any[], buffer: Int8Array | Uint8Array | Int16Array | Uint16Array | Int32Array | Uint32Array, startOffset: number): void;
    getBuffer(): Int8Array | Uint8Array | Int16Array | Uint16Array | Int32Array | Uint32Array;
    getDataRange(): object;
    getGeometry(): Geometry;
    getHistogram(): any[];
    getImageUid(index?: Index): string;
    getMeta(): object;
    getNumberOfComponents(): number;
    getOffsets(value: number | object): any[];
    getPhotometricInterpretation(): string;
    getPlanarConfiguration(): number;
    getRescaledDataRange(): object;
    getRescaledValue(i: number, j: number, k: number, f: number): number;
    getRescaledValueAtIndex(index: Index): number;
    getRescaledValueAtOffset(offset: number): number;
    getRescaleSlopeAndIntercept(index?: Index): RescaleSlopeAndIntercept;
    getSecondaryOffset(index: Index): number;
    getValue(i: number, j: number, k: number, f: number): number;
    getValueAtIndex(index: Index): number;
    getValueAtOffset(offset: number): number;
    hasValues(values: any[]): any[];
    isConstantRSI(): boolean;
    isIdentityRSI(): boolean;
    removeEventListener(type: string, callback: Function): void;
    setAtOffsets(offsets: any[], value: object): void;
    setAtOffsetsAndGetOriginals(offsetsLists: any[], value: object): any[];
    setAtOffsetsWithIterator(offsetsLists: any[], value: object | any[]): void;
    setMeta(rhs: object): void;
    setPhotometricInterpretation(interp: string): void;
    setPlanarConfiguration(config: number): void;
    setRescaleSlopeAndIntercept(inRsi: RescaleSlopeAndIntercept, offset?: number): void;
    transform(operator: Function): Image_2;
}
export { Image_2 as Image }

// @public
export class Index {
    constructor(values: number[]);
    add(rhs: Index): Index;
    canCompare(rhs: Index): boolean;
    compare(rhs: Index): number[];
    equals(rhs: Index): boolean;
    get(i: number): number | undefined;
    getValues(): number[];
    getWithNew2D(i: number, j: number): Index;
    length(): number;
    toString(): string;
    toStringId(dims?: number[]): string;
}

// @public
export function labToUintLab(triplet: object): object;

// @public
export class LayerGroup {
    constructor(containerDiv: HTMLElement);
    addDrawLayer(): DrawLayer;
    addEventListener(type: string, callback: Function): void;
    addScale(scaleStep: number, center: Point3D): void;
    addTranslation(translation: object): void;
    addViewLayer(): ViewLayer;
    calculateFitScale(): number | undefined;
    display(flag: boolean): void;
    draw(): void;
    empty(): void;
    flipScaleZ(): void;
    getActiveDrawLayer(): DrawLayer | undefined;
    getActiveViewLayer(): ViewLayer | undefined;
    getAddedScale(): object;
    getBaseScale(): object;
    getDivId(): string;
    getDrawLayersByDataId(dataId: string): DrawLayer[];
    getMaxSize(): object | undefined;
    getNumberOfLayers(): number;
    getNumberOfViewLayers(): number;
    getOffset(): object;
    getScale(): object;
    getShowCrosshair(): boolean;
    getViewDataIndices(): any[];
    getViewLayersByDataId(dataId: string): ViewLayer[];
    removeEventListener(type: string, callback: Function): void;
    removeLayer(layer: ViewLayer | DrawLayer): void;
    reset(): void;
    searchViewLayers(meta: object): ViewLayer[];
    setActiveDrawLayer(index: number): void;
    setActiveDrawLayerByDataId(dataId: string): void;
    setActiveViewLayer(index: number): void;
    setActiveViewLayerByDataId(dataId: string): void;
    setFitScale(scaleIn: number): void;
    setImageSmoothing(flag: boolean): void;
    setOffset(newOffset: object): void;
    setScale(newScale: object, center?: Point3D): void;
    setShowCrosshair(flag: boolean): void;
    updateLayersToPositionChange: (event: object) => void;
}

// @public (undocumented)
export namespace logger {
    // (undocumented)
    export function debug(msg: string): void;
    let // (undocumented)
    level: number;
    // (undocumented)
    export function error(msg: string): void;
    // (undocumented)
    export function info(msg: string): void;
    // (undocumented)
    export namespace levels {
        let // (undocumented)
        TRACE: number;
        let // (undocumented)
        DEBUG: number;
        let // (undocumented)
        INFO: number;
        let // (undocumented)
        WARN: number;
        let // (undocumented)
        ERROR: number;
    }
    // (undocumented)
    export function trace(msg: string): void;
    // (undocumented)
    export function warn(msg: string): void;
}

// @public
export const luts: {
    [x: string]: ColourMap;
};

// @public
export class MaskFactory {
    // (undocumented)
    checkElements(_dicomElements: any): void;
    // Warning: (ae-forgotten-export) The symbol "DataElements" needs to be exported by the entry point index.d.ts
    create(dataElements: DataElements, pixelBuffer: Uint8Array | Int8Array | Uint16Array | Int16Array | Uint32Array | Int32Array): Image_2;
}

// @public
export class Matrix33 {
    constructor(values: number[]);
    asOneAndZeros(): Matrix33;
    equals(rhs: Matrix33, p?: number): boolean;
    get(row: number, col: number): number | undefined;
    getAbs(): Matrix33;
    getColAbsMax(col: number): object;
    getInverse(): Matrix33 | undefined;
    getRowAbsMax(row: number): object;
    getThirdColMajorDirection(): number;
    multiply(rhs: Matrix33): Matrix33;
    multiplyArray3D(array3D: number[]): number[];
    multiplyIndex3D(index3D: Index): Index;
    multiplyPoint3D(point3D: Point3D): Point3D;
    multiplyVector3D(vector3D: Vector3D): Vector3D;
    toString(): string;
}

// @public
export class OverlayData {
    constructor(app: App, dataId: string, configs: object);
    addAppListeners(): void;
    addEventListener(type: string, callback: object): void;
    addItemMeta(data: object): void;
    isListening(): boolean;
    removeAppListeners(): void;
    removeEventListener(type: string, callback: object): void;
    reset(): void;
}

// @public
export class Point {
    constructor(values: number[]);
    add(rhs: Point): Point;
    canCompare(rhs: Point): boolean;
    compare(rhs: Point): number[];
    equals(rhs: Point): boolean;
    get(i: number): number;
    get3D(): Point3D;
    getValues(): number[];
    length(): number;
    mergeWith3D(rhs: Point3D): Point;
    toString(): string;
}

// @public
export class Point2D {
    constructor(x: number, y: number);
    equals(rhs: Point2D): boolean;
    getDistance(point2D: Point2D): number;
    getRound(): Point2D;
    getX(): number;
    getY(): number;
    toString(): string;
}

// @public
export class Point3D {
    constructor(x: number, y: number, z: number);
    equals(rhs: Point3D): boolean;
    getDistance(point3D: Point3D): number;
    getX(): number;
    getY(): number;
    getZ(): number;
    isSimilar(rhs: Point3D, tol: number): boolean;
    minus(point3D: Point3D): Vector3D;
    toString(): string;
}

// @public
export function precisionRound(number: number, precision: number): number;

// @public
export class RescaleLut {
    constructor(rsi: RescaleSlopeAndIntercept, bitsStored: number);
    getLength(): number;
    getRSI(): RescaleSlopeAndIntercept;
    getValue(offset: number): number;
}

// @public
export class RescaleSlopeAndIntercept {
    constructor(slope: number, intercept: number);
    apply(value: number): number;
    equals(rhs: RescaleSlopeAndIntercept): boolean;
    getIntercept(): number;
    getSlope(): number;
    isID(): boolean;
}

// @public
export class Size {
    constructor(values: any[]);
    canScroll(viewOrientation: Matrix33): boolean;
    canScroll3D(viewOrientation?: Matrix33): boolean;
    equals(rhs: Size): boolean;
    get(i: number): number;
    get2D(): object;
    getDimSize(dimension: number, start?: number): number;
    getTotalSize(start?: number): number;
    getValues(): any[];
    indexToOffset(index: Index, start?: number): number;
    isInBounds(index: Index, dirs: any[]): boolean;
    length(): number;
    moreThanOne(dimension: number): boolean;
    offsetToIndex(offset: number): Index;
    toString(): string;
}

// @public
export class Spacing {
    constructor(values: any[]);
    equals(rhs: Spacing): boolean;
    get(i: number): number;
    get2D(): object;
    getValues(): any[];
    length(): number;
    toString(): string;
}

// @public
export function srgbToCielab(triplet: object): object;

// @public
export class Tag {
    constructor(group: string, element: string);
    equals(rhs: Tag): boolean;
    getElement(): string;
    getGroup(): string;
    getGroupName(): string;
    getInfoFromDictionary(): any[] | undefined;
    getKey(): string;
    getNameFromDictionary(): string | undefined;
    getVrFromDictionary(): string | undefined;
    isPrivate(): boolean;
    isWithVR(): boolean;
    toString(): string;
}

// @public
export class TagValueExtractor {
    getTime(_elements: {
        [x: string]: DataElement;
    }): number | undefined;
}

// @public
export class ToolboxController {
    constructor(toolList: object);
    bindLayerGroup(layerGroup: LayerGroup, layer: ViewLayer | DrawLayer): void;
    getSelectedTool(): object;
    getSelectedToolEventHandler(eventType: string): Function;
    getToolList(): any[];
    hasTool(name: string): boolean;
    init(): void;
    setSelectedTool(name: string): void;
    setToolFeatures(list: object): void;
}

// @public
export class ToolConfig {
    constructor(options?: string[]);
    options: string[] | undefined;
}

// @public (undocumented)
export namespace toolList {
        { WindowLevel };
        { Scroll };
        { ZoomAndPan };
        { Opacity };
        { Draw };
        { Filter };
        { Floodfill };
        { Livewire };
}

// @public
export class Vector3D {
    constructor(x: number, y: number, z: number);
    crossProduct(vector3D: Vector3D): Vector3D;
    dotProduct(vector3D: Vector3D): number;
    equals(rhs: Vector3D): boolean;
    getX(): number;
    getY(): number;
    getZ(): number;
    norm(): number;
    toString(): string;
}

// @public
export class View {
    constructor(image: Image_2);
    addEventListener(type: string, callback: Function): void;
    addWindowPresets(presets: object): void;
    canSetPosition(position: Point): boolean;
    decrementIndex(dim: number, silent: boolean): boolean;
    decrementScrollIndex(silent: boolean): boolean;
    generateImageData(data: ImageData, index: Index): void;
    getAlphaFunction(): (value: object, index: object) => number;
    getColourMap(): string;
    getCurrentIndex(): Index;
    getCurrentPosition(): Point;
    getCurrentWindowLut(): WindowLut;
    getCurrentWindowPresetName(): string;
    getImage(): Image_2;
    getOrientation(): Matrix33;
    getOrigin(position?: Point): Point3D;
    getPlaybackMilliseconds(recommendedDisplayFrameRate: number): number;
    getScrollIndex(): number;
    getWindowLevelMinMax(): WindowCenterAndWidth;
    getWindowPresets(): object;
    getWindowPresetsNames(): object;
    incrementIndex(dim: number, silent: boolean): boolean;
    incrementScrollIndex(silent: boolean): boolean;
    init(): void;
    removeEventListener(type: string, callback: Function): void;
    setAlphaFunction(func: (value: object, index: object) => number): void;
    setColourMap(name: string): void;
    setCurrentIndex(index: Index, silent?: boolean): boolean;
    setCurrentPosition(position: Point, silent: boolean): boolean;
    setImage(inImage: Image_2): void;
    setInitialIndex(): void;
    setOrientation(mat33: Matrix33): void;
    setWindowLevel(center: number, width: number, name?: string, silent?: boolean): void;
    setWindowLevelMinMax(): void;
    setWindowLevelPreset(name: string, silent?: boolean): void;
    setWindowLevelPresetById(id: number, silent?: boolean): void;
    setWindowPresets(presets: object): void;
}

// @public
export class ViewConfig {
    constructor(divId: string);
    colourMap: string | undefined;
    divId: string;
    opacity: number | undefined;
    orientation: string | undefined;
}

// @public
export class ViewController {
    constructor(view: View, dataId: string);
    addEventListener(type: string, callback: Function): void;
    addWindowLevelPresets(presets: object): object;
    applyHiddenSegments(): void;
    canQuantifyImage(): boolean;
    canScroll(): boolean;
    canSetPosition(position: Point): boolean;
    canWindowLevel(): boolean;
    decrementIndex(dim: number, silent?: boolean): boolean;
    decrementScrollIndex(silent?: boolean): boolean;
    deleteSegment(segmentNumber: number, exeCallback: Function): void;
    equalImageMeta(meta: object): boolean;
    generateImageData(array: ImageData, index: Index): void;
    get2DSpacing(): any[];
    getColourMap(): string;
    getCurrentIndex(): Index;
    getCurrentOrientedIndex(): Index;
    getCurrentPosition(): Point;
    getCurrentScrollIndexValue(): object;
    getCurrentScrollPosition(): object;
    getCurrentWindowPresetName(): string;
    getImageRegionValues(min: Point2D, max: Point2D): any[];
    getImageRescaledDataRange(): object;
    getImageSize(): Size;
    getImageVariableRegionValues(regions: any[]): any[];
    getImageWorldSize(): object;
    getMaskSegmentHelper(): object;
    getModality(): string;
    getOffset3DFromPlaneOffset(offset2D: object): Vector3D;
    getOrigin(position?: Point): Point3D;
    getPixelUnit(): string;
    getPlaneHelper(): object;
    getPlanePositionFromPlanePoint(point2D: object): Point3D;
    getPlanePositionFromPosition(point: Point): object;
    getPositionFromPlanePoint(x: number, y: number): Point;
    getRescaledImageValue(position: Point): number | undefined;
    getScrollIndex(): number;
    getWindowLevel(): object;
    getWindowLevelPresetsNames(): any[];
    incrementIndex(dim: number, silent?: boolean): boolean;
    incrementScrollIndex(silent?: boolean): boolean;
    initialise(): void;
    isMask(): boolean;
    isPlaying(): boolean;
    play(): void;
    removeEventListener(type: string, callback: Function): void;
    setColourMap(name: string): void;
    setCurrentIndex(index: Index, silent?: boolean): boolean;
    setCurrentPosition(pos: Point, silent?: boolean): boolean;
    setImage(img: Image_2, dataId: string): void;
    setViewAlphaFunction(func: (value: object, index: object) => number): void;
    setWindowLevel(wc: number, ww: number): void;
    setWindowLevelPreset(name: string): void;
    setWindowLevelPresetById(id: number): void;
    stop(): void;
}

// @public
export class ViewLayer {
    constructor(containerDiv: HTMLElement);
    addEventListener(type: string, callback: Function): void;
    addFlipOffsetX(): void;
    addFlipOffsetY(): void;
    bindInteraction(): void;
    clear(): void;
    display(flag: boolean): void;
    displayToMainPlanePos(x: number, y: number): object;
    displayToPlaneIndex(x: number, y: number): Index;
    displayToPlanePos(x: number, y: number): object;
    displayToPlaneScale(x: number, y: number): object;
    draw(): void;
    fitToContainer(fitScale1D: number, fitSize: object, fitOffset: object): void;
    flipScaleZ(): void;
    getBaseSize(): object;
    getDataId(): string;
    getId(): string;
    getImageData(): object;
    getImageWorldSize(): object;
    getOpacity(): number;
    getViewController(): ViewController;
    initialise(size: object, spacing: object, alpha: number): void;
    isVisible(): boolean;
    onimagechange: (event: object) => void;
    onimageset: (event: object) => void;
    planePosToDisplay(x: number, y: number): object;
    removeEventListener(type: string, callback: Function): void;
    setBaseOffset(scrollOffset: Vector3D, planeOffset: Vector3D): boolean;
    setCurrentPosition(position: Point, _index: Index): boolean;
    setImageSmoothing(flag: boolean): void;
    setOffset(newOffset: object): void;
    setOpacity(alpha: number): void;
    setScale(newScale: object, center?: Point3D): void;
    setView(view: object, dataId: string): void;
    unbindInteraction(): void;
}

// @public
export class WindowCenterAndWidth {
    constructor(center: number, width: number);
    apply(value: number): number;
    equals(rhs: WindowCenterAndWidth): boolean;
    getCenter(): number;
    getWidth(): number;
    setSignedOffset(offset: number): void;
}

// @public
export class WindowLut {
    constructor(rescaleLut: RescaleLut, isSigned: boolean, isDiscrete: boolean);
    getRescaleLut(): RescaleLut;
    getValue(offset: number): number;
    getWindowLevel(): WindowCenterAndWidth;
    setWindowLevel(wl: WindowCenterAndWidth): void;
}

// @public
export class WriterRule {
    constructor(action: string);
    action: string;
    value: any | undefined;
}

// (No @packageDocumentation comment for this package)

```
